/*
     тестовое подключение дисплей типа HT1621B
*/

// #include "stest3.h" // относится к текущему файлу

#define  data 10 // соответствие номеру вывода D10 (перед употреблением заменить на имеющийся согласно схемы!)
#define  wr 11 // соответствие номеру вывода D11 (перед употреблением заменить на имеющийся согласно схемы!)
#define  cs 12 // соответствие номеру вывода D12 (перед употреблением заменить на имеющийся согласно схемы!)

#define  biass  B00101000 // LCD 1/2 bias option, 4 common option
#define  clc_on  1 // пуск системного генератора
#define  lcd_on  3 // turn ON  LCD bias generanor
#define  wait_time 1000 //время паузы действия индикации текущего сегмента
byte ln_dat = data; // переменная со значением номера вывода линии данных
byte ln_wr = wr; // переменная со значением номера вывода линии строба записи
byte ln_cs = cs; // переменная со значением номера вывода линии строба выборки кристалла
byte ptrc = 0; // начальная инициализация счетчика бит
byte bufout[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // массив буфера данных для пакетной загрузки

/*
 *  раздел с описанием (определением) применяемых в программе самодельных функций
*/


// начальный статус линий интерфейса (он же и заглушка завершения пакета)
void stop_pack ();

// строб сопровождения данных
void data_clock();

// запись заголовка с составляющими командными словами для активации режима дисплея
void wr_uksda(byte,byte,byte);

// запись байта команды
void trs_com(byte);

// запись пакета bufout (в комплекте с командным заголовком)
void wr_ksda(byte*);

// блок вращения бита в массиве
//void rotor_16();

// блок препарирования данных под карту ОЗУ
void converts (byte*, byte*); // указатель на источник, указатель на приемник

//
void rotor_mx5(byte*, byte); // параметры: указатель на массив передатчика(bufout) и
                         // значение вдвигаемого бита

// -----------------------------------

/*
 * функционал преобразования беззнакового целого
 *  формата 0-65535 в четыре тетрады 
 *  двоично-десятичного эквивалента, 
 *  размещаемых в буфере tmp_seg
*/

// массив буфера преобразований (общий для всех программ предподготовки вывода данных)
byte tmp_seg[] {0,0,0,0,0};

// функция преобразования
void bindec (byte*,unsigned int); // параметры: указатель на массив обработчика(tmp_seg),
                             // и собственно данные (0-65535)

// -----------------------------------

/*
* функционал знакогенератора
* данные, взятые из текущей ячейки tmp_seg
* преобразуются в соответствующий им
* сегментный код
*/

/* 
* объявляем константы привязки сегментов к позиции в байте
* знакогенератора (или произвольного синтеза символа)
* выставляется в соответствии с результатами посегментного теста
* конкретного дисплея
*/
#define SEG_A 4 // позиционный индекс сегмента A
#define SEG_B 7 // позиционный индекс сегмента B
#define SEG_C 6 // позиционный индекс сегмента C
#define SEG_D 2 // позиционный индекс сегмента D
#define SEG_E 0 // позиционный индекс сегмента E
#define SEG_F 1 // позиционный индекс сегмента F
#define SEG_G 3 // позиционный индекс сегмента G
#define SEG_H 5 // позиционный индекс сегмента H
#define  simw0 (1<<SEG_A | 1<<SEG_B | 1<<SEG_C | 1<<SEG_D | 1<<SEG_E | 1<<SEG_F)
#define  simw1 (1<<SEG_B | 1<<SEG_C)
#define  simw2 (1<<SEG_A | 1<<SEG_B | 1<<SEG_G | 1<<SEG_E | 1<<SEG_D)
#define  simw3 (1<<SEG_A | 1<<SEG_B | 1<<SEG_C | 1<<SEG_D | 1<<SEG_G)
#define  simw4 (1<<SEG_F | 1<<SEG_G | 1<<SEG_B | 1<<SEG_C)
#define  simw5 (1<<SEG_A | 1<<SEG_F | 1<<SEG_G | 1<<SEG_C | 1<<SEG_D)
#define  simw6 (1<<SEG_A | 1<<SEG_F | 1<<SEG_G | 1<<SEG_C | 1<<SEG_D | 1<<SEG_E)
#define  simw7 (1<<SEG_A | 1<<SEG_B | 1<<SEG_C)
#define  simw8 (1<<SEG_A | 1<<SEG_B | 1<<SEG_C | 1<<SEG_D | 1<<SEG_E | 1<<SEG_F | 1<<SEG_G)
#define  simw9 (1<<SEG_A | 1<<SEG_B | 1<<SEG_C | 1<<SEG_D | 1<<SEG_F | 1<<SEG_G)
#define  simwA (1<<SEG_A | 1<<SEG_B | 1<<SEG_C | 1<<SEG_E | 1<<SEG_F | 1<<SEG_G)
#define  simwB (1<<SEG_C | 1<<SEG_D | 1<<SEG_E | 1<<SEG_F | 1<<SEG_G)
#define  simwC (1<<SEG_A | 1<<SEG_D | 1<<SEG_E | 1<<SEG_F)
#define  simwD (1<<SEG_B | 1<<SEG_C | 1<<SEG_D | 1<<SEG_E | 1<<SEG_G)
#define  simwE (1<<SEG_A | 1<<SEG_D | 1<<SEG_E | 1<<SEG_F | 1<<SEG_G)
#define  simwF (1<<SEG_F | 1<<SEG_E | 1<<SEG_A | 1<<SEG_G)

// собственно знакогенератор для тетрадного кода 0х00- 0x0F
void znak_seg (byte*); // параметры: указатель на массив с тетрадами двоичного эквивалента
                    // результата десятичного или двоичного преобразования

// -----------------------------------

/*
 * функционал перегрузки содержимого сегментных кодов из
 * буфера tmp_seg в буфер вывода bufout
 * под конкретный дисплей в 4 позиции
 */
void carrying_4(byte*,byte*); // параметры: указатели на массив-приемник (bufout) и
                           // массив-источник (tmp_seg)

// -------------------------------------------------------------------------

void setup() 
{
  Serial.begin(9600); // запуск последовательного интерфейса  
  pinMode(ln_dat, OUTPUT);
  pinMode(ln_wr, OUTPUT);
  pinMode(ln_cs , OUTPUT);
  digitalWrite(ln_cs, HIGH); // исходное состояние = 1
  digitalWrite(ln_wr, HIGH); // исходное состояние = 1
  digitalWrite(ln_dat, HIGH); // исходное состояние = 1
  wr_uksda(biass, clc_on, lcd_on);
  wr_ksda(bufout); // начальная инициализация дисплея "все погашены"
  delay(wait_time);
}

// -------------------------------------------------------------------------

void loop() 
{
  // put your main code here, to run repeatedly:
/*
 * распечатка на терминале значений в каждой из ячеек tmp_seg
 * их десятичного эквивалента
 * и шестнадцатеричных сегментных кодов для каждой позиции
 * с одновременным выводом информации в четыре первых позиции дисплея
 * 
 * NNNN_DDDD
 * HH_HH_HH_HH_
 * 
 */
    for (unsigned int a=0; a<=9999; a++)
   {
    bindec(tmp_seg,a);
     for (byte cnt=0; cnt<=4; cnt++)
      {Serial.print(tmp_seg[cnt], HEX);}
        Serial.print("_"); Serial.print(a, DEC); Serial.println("");
       znak_seg (tmp_seg);
      for (byte cnt=1; cnt<=4; cnt++)
       {Serial.print(tmp_seg[cnt], HEX);Serial.print("_");}
         Serial.println("");
      //carrying_4(bufout, tmp_seg);
      converts(bufout, tmp_seg);
     wr_ksda(bufout); // проводим вывод пакета в дисплей
     delay(wait_time); // и после задержки в … секунды снова повторяем
   }
}

// -------------------------------------------------------------------------

/*
    здесь размещаем реализацию наших функции - подпрограммок
    используемых в вышерасположенных void setup() , void loop() а также
    наши самодельные функции поменьше, используемые при реализации более крупных
    собственно всего того, что заявлено выше в разделе
    описанием (определением) применяемых в программе самодельных функций
*/

// начальный статус линий интерфейса (он же и заглушка завершения пакета)
//подразумевается, что линия  ln_wr уже установлена в 1 или при начальной
// инициализации или по завершении строб-импульса

  void stop_pack ()
{
  digitalWrite(ln_dat, HIGH);
  delayMicroseconds(6);
  digitalWrite(ln_cs, HIGH);
}

// строб сопровождения данных
  void data_clock()
{
  digitalWrite(ln_wr, LOW);
  delayMicroseconds(3);
  digitalWrite(ln_wr, HIGH);
  delayMicroseconds(3);
}

// запись байта команды (может быть выполнена как shiftOut)
  void trs_com(byte com_word)
{ byte ptrb=7;
   for (byte count=0; count<=7; count++)
    {
     digitalWrite(ln_dat, bitRead(com_word,ptrb));
     data_clock(); ptrb--;
    }
  data_clock(); // стробирует девятый бит командного слова (его состояние безразлично)
}

// запись заголовка с составляющими командными словами для активации режима дисплея
 void wr_uksda(byte a,byte b,byte c)
{
  digitalWrite(ln_cs, LOW);
  delayMicroseconds(6);
  data_clock();
  digitalWrite(ln_dat, LOW);
  data_clock();
  data_clock(); // преамбула "запись команд" 100
  trs_com(a); // LCD 1/2 bias option, 3 common option
  trs_com(b); // пуск системного генератора
  trs_com(c); // включить LCD bias generator
  stop_pack();
}

/* пересылка данных в ОЗУ дисплея из ОЗУ  bufout
* без разрушения содержимого  bufout
 */
 void wr_ksda(byte *ptrs)
{
  digitalWrite(ln_cs, LOW);
  delayMicroseconds(6);
  data_clock();
  digitalWrite(ln_dat, LOW);
  data_clock();
  digitalWrite(ln_dat, HIGH);
  data_clock(); // преамбула "запись ОЗУ" 101
  digitalWrite(ln_dat, LOW);
  for (byte cnt=0; cnt<=5; cnt++)
   {
     data_clock(); // начальный адрес (6бит) = 0
   } // отсылаем начальный адрес пакета
//заголовок-преамбула завершен, далее собственно пошли данные
  for (byte cnt=0; cnt<=15; cnt++)
  {
    // неразрушающая обработка байта с пересылкой
    for (byte ptrb=0; ptrb<=7; ptrb++)
     {
       digitalWrite(ln_dat, bitRead(ptrs[cnt],ptrb)); // бит 0 текущего байта
       data_clock();
     }
  }
  stop_pack();
}

// -----------------------------------

/*
 * функционал преобразования беззнакового целого
 *  формата 0-65535 в пять тетрад 
 *  двоично-десятичного эквивалента, 
 *  размещаемых в буфере tmp_seg
*/

void bindec (byte *n,unsigned int a)
 {
   for (int cnt=0; cnt<=4; cnt++)
    {*(n+cnt)=0;} // очистка буфера
   if (a>=10000)
     {*(n+0)=a/10000; a=a%10000;} // тетрада десятков тысяч
   if (a>=1000)
    {*(n+1)=a/1000; a=a%1000;} // тетрада тысяч
    if (a>=100)
     {*(n+2)=a/100; a=a%100;} // тетрада сотен
     if (a>=10)
      {*(n+3)=a/10; a=a%10;} // тетрада десятков
        *(n+4)=a; // тетрада единиц
  }

// -----------------------------------

/*
 * преобразование тетрад двоично-десятичного 
 * эквивалента в сегментный код 
 * отображения символа на дисплее
 */
 
void znak_seg (byte *n)
 {
  for (byte cnt=0; cnt<=4; cnt++)
   {
    switch (*(n+cnt))
     {
      case 0:
       *(n+cnt)=simw0; break;
      case 1:
       *(n+cnt)=simw1; break;
      case 2:
       *(n+cnt)=simw2; break;
      case 3:
       *(n+cnt)=simw3; break;
      case 4:
       *(n+cnt)=simw4; break;
      case 5:
       *(n+cnt)=simw5; break;
      case 6:
       *(n+cnt)=simw6; break;
      case 7:
       *(n+cnt)=simw7; break;
      case 8:
       *(n+cnt)=simw8; break;
      case 9:
       *(n+cnt)=simw9; break;
      case 0x0a:
       *(n+cnt)=simwA; break;
      case 0x0b:
       *(n+cnt)=simwB; break;
      case 0x0c:
       *(n+cnt)=simwC; break;
      case 0x0d:
       *(n+cnt)=simwD; break;
      case 0x0e:
       *(n+cnt)=simwE; break;
      case 0x0f:
       *(n+cnt)=simwF; break;
     }
   }
 }

// -----------------------------------

/*
 * функционал перегрузки содержимого сегментных кодов из
 * буфера tmp_seg в буфер вывода bufout
 * под конкретный дисплей в 4 позиции
 */
 
void carrying_4(byte *ptrd, byte *ptrs)
 {
   for (byte cnt=1; cnt<=4; cnt++)
    {
     *(ptrd+(cnt-1))=*(ptrs+cnt);
    }
 }

// -----------------------------------

/* 
 *  блок препарирования данных под карту ОЗУ
 *  под мой вариант раскладки сегментов
 *  загрузка в первые пять знакомест
 *  содержимое остальных - НЕ ОПРЕДЕЛЕНО
 *  в противном случае требуется дополнительная
 *  процедура предочистки содержимого 
 *  буфера назначения bufout
 */

void converts (byte *ptrd, byte *ptrs) // указатель на приемник, указатель на источник
 { byte ptrb=4;
   for (byte cnt=0; cnt<=4; cnt++)
    {
      rotor_mx5(ptrd,0);
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],7));
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],6));
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],5));
      rotor_mx5(ptrd,0);
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],4));
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],3));
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],2));
      rotor_mx5(ptrd,0);
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],1));
      rotor_mx5(ptrd,bitRead(ptrs[ptrb],0));
      rotor_mx5(ptrd,0);
      ptrb--;
    }
 }

// -----------------------------------

// блок вращения бита в массиве
// заполняет временный массив преобразованными сегментными данными
// с последующим переносом данных в bufout[0]-bufout[7] (ptrd[0]-ptrd[7]
// поскольку каждое знакоместо занимает 3 тетрады на пять знакомест надо 15 тетрад
// или 7,5 байт - берем размер буфера в 8 целых байт
void rotor_mx5(byte *ptrd, byte a)
 {
    byte b=0;
    for (byte cntpd=0; cntpd<=7; cntpd++)
      {
        // читаем элемент массива в буфер обработки
       b = bitRead(ptrd[cntpd],7); //  b может принять значения 0 иди 1
       ptrd[cntpd] = a | (ptrd[cntpd] << 1); // сдвиг данных совмещенный с операцией ИЛИ
                          // по содержимому в а (0000000N) и вернуть новое значение в элемент массива
       a = b; // скрпируем текущий флаг переноса из  b в а
            // и повторим это для всех 8 байт массива
      }
      ptrd[7]=ptrd[7]&0x0f; // блокируем состояние "лишней тетрады"
 }

